package net.krakatoa.proxy.command;

import de.dytanic.cloudnet.driver.CloudNetDriver;
import de.dytanic.cloudnet.driver.permission.IPermissionUser;
import earth.krakatao.protocol.KraSocketClientProtocolMessage;
import earth.krakatao.protocol.KraSocketClientProtocolStatus;
import java.util.function.Consumer;
import net.krakatoa.proxy.ProxySystem;
import net.md_5.bungee.api.CommandSender;
import net.md_5.bungee.api.chat.TextComponent;
import net.md_5.bungee.api.connection.ProxiedPlayer;
import net.md_5.bungee.api.plugin.Command;

public class SendTestMessageCommand extends Command {

  // /sendTestMessage <status> <cmdID> <dest> <cmdNumber> <msg>

  public SendTestMessageCommand(String name) {
    super(name);
  }

  @Override
  public void execute(CommandSender commandSender, String[] args) {
    if (commandSender instanceof ProxiedPlayer) {
      ProxiedPlayer proxiedPlayer = (ProxiedPlayer) commandSender;

      IPermissionUser permissionUser = CloudNetDriver.getInstance().getPermissionManagement()
          .getUser(proxiedPlayer.getUniqueId());

      if (permissionUser != null && permissionUser.hasPermission("*").asBoolean()) {
        if (args.length == 5) {
          try {
            int cmdID;

            byte status = Byte.parseByte(args[0]);

            if (status == KraSocketClientProtocolStatus.GET.getStatus()) {
              cmdID = ProxySystem.getInstance().getKraSocketClientProtocol().generateCmdID();
            } else {
              cmdID = Byte.parseByte(args[1]);
            }

            Consumer<KraSocketClientProtocolMessage> consumer = null;
            if (status == KraSocketClientProtocolStatus.GET.getStatus()) {
              consumer = kraSocketClientProtocolMessage -> {
                proxiedPlayer.sendMessage(new TextComponent(
                    "Received msg -> status:" + kraSocketClientProtocolMessage.getStatus()
                        + " cmdID: "
                        + kraSocketClientProtocolMessage.getCmdID() + " dest: "
                        + kraSocketClientProtocolMessage.getDest() + " uuid: "
                        + kraSocketClientProtocolMessage.getUuid() + " cmdNumber: "
                        + kraSocketClientProtocolMessage.getCmdNumber() + " args: "
                        + kraSocketClientProtocolMessage.getArgs()));
              };
            }

            KraSocketClientProtocolMessage kraSocketClientProtocolMessage = null;

            kraSocketClientProtocolMessage = new KraSocketClientProtocolMessage(
                status, (byte) cmdID, Integer.parseInt(args[2]),
                proxiedPlayer.getUniqueId(), Integer.parseInt(args[3]), args[4],
                consumer);

            ProxySystem.getInstance().getKraSocketClient().getSocketClient()
                .SendMessage(kraSocketClientProtocolMessage);
          } catch (NumberFormatException exception) {
            proxiedPlayer.sendMessage(new TextComponent("§7Error: §cNumberFormatException"));
          }
        } else {
          proxiedPlayer.sendMessage(new TextComponent(
              "§cVerwendung: §7/sendTestMessage <status> <cmdID> <dest> <cmdNumber> <msg>"));
        }
      }
    }
  }
}
